smart_arrays_numerics 2.0.2

  • README.md
  • CHANGELOG.md
  • Example
  • Installing
  • Versions
  • new67

Smart Arrays Numerics #

What the package can do for you #

  • Creating a matrix / diagonal matrix / cloning matrix.
  • Various numeric operations with matrices and vectors such as summation, multiplication, comparison.
  • Inverting and transposing a matrix.

The major API functionalities #

  • Available in the class Numerics.

Detailed API #

Please view the detailed API documentation in the API reference of this package (sidebar at the right of this page).

Using this package #

You need Dart 2.0 or later.

Import the package using:

  • import 'package:smart_arrays_numerics/smart_arrays_numerics.dart';

smart_arrays_base: Basic functions for 1D and 2D arrays

smart_arrays_compress: Compress 1D and 2D arrays to a smaller size.

smart_arrays_peaks: Detect peaks in 1D and 2D arrays.

smart_arrays_lmfit: Fits (x, y) data given as arrays to a specified model function using the Levenberg-Marquardt algorithm.

smart_lorentz-gauss: Compute Lorentz-Gauss (pseudo-Voigt) line shapes.

smart_signal_processing: Fourier transform and more.

smart_dialogs: Easy-to-use dialogs in Web applications

Smart Arrays Numerics #

Version history #

2.0.0 - 2019-04-02 First version available on pub site.

2.0.1 - 2019-04-04 Doc updates.

2.0.2 - 2019-04-14 Added compareMM function and some tests.

example/example.dart

// Copyright (c) 2019, Dr. Bruno Guigas. All rights reserved. Use of this source
// code is governed by a BSD-style license that can be found in the LICENSE file.
import 'package:smart_arrays_numerics/smart_arrays_numerics.dart';

/// Demonstrates matrix inversion, diagonal, transpose.
main() {
  Numerics nu = Numerics();
  final List<List<double>> mat = [
    [1, 1, 1, 0],
    [0, 3, 1, 2],
    [2, 3, 1, 0],
    [1, 0, 2, 1]
  ];

  List<List<double>> inverse, identity;

  try {
    inverse = nu.invMatrix(mat); // invert
    identity = nu.dotMM(mat, inverse); // product must give identity
    print("inverse=$inverse");
    print("identity=$identity");
    print("diagonal inverse=${nu.getDiag(inverse)}");
  } catch (e) {
    print("not invertible: $mat");
  }

  final List<List<double>> mat2 = [
    [1, 1, 1],
    [0, 3, 1],
    [2, 3, 1],
    [1, 0, 2]
  ];

  List<List<double>> transposed = nu.transpose(mat2);
  print("transposed=$transposed");
  print("diagonal transposed=${nu.getDiag(transposed)}");
}

Use this package as a library

1. Depend on it

Add this to your package's pubspec.yaml file:


dependencies:
  smart_arrays_numerics: ^2.0.2

2. Install it

You can install packages from the command line:

with pub:


$ pub get

with Flutter:


$ flutter packages get

Alternatively, your editor might support pub get or flutter packages get. Check the docs for your editor to learn more.

3. Import it

Now in your Dart code, you can use:


import 'package:smart_arrays_numerics/smart_arrays_numerics.dart';
  
Version Uploaded Documentation Archive
2.0.2 Apr 14, 2019 Go to the documentation of smart_arrays_numerics 2.0.2 Download smart_arrays_numerics 2.0.2 archive
2.0.1 Apr 4, 2019 Go to the documentation of smart_arrays_numerics 2.0.1 Download smart_arrays_numerics 2.0.1 archive
2.0.0 Apr 3, 2019 Go to the documentation of smart_arrays_numerics 2.0.0 Download smart_arrays_numerics 2.0.0 archive
Popularity:
Describes how popular the package is relative to other packages. [more]
34
Health:
Code health derived from static analysis. [more]
100
Maintenance:
Reflects how tidy and up-to-date the package is. [more]
100
Overall:
Weighted score of the above. [more]
67
Learn more about scoring.

We analyzed this package on Apr 18, 2019, and provided a score, details, and suggestions below. Analysis was completed with status completed using:

  • Dart: 2.2.0
  • pana: 0.12.14

Platforms

Detected platforms: Flutter, web, other

No platform restriction found in primary library package:smart_arrays_numerics/smart_arrays_numerics.dart.

Health suggestions

Format lib/src/numerics.dart.

Run dartfmt to format lib/src/numerics.dart.

Dependencies

Package Constraint Resolved Available
Direct dependencies
Dart SDK >=2.1.0 <3.0.0
build_runner ^1.1.2 1.3.3
build_web_compilers ^1.0.0 1.2.1 2.0.0-alpha.2
pedantic ^1.5.0 1.5.0
Transitive dependencies
analyzer 0.35.4 0.36.0
archive 2.0.8
args 1.5.1
async 2.2.0
bazel_worker 0.1.20
build 1.1.3
build_config 0.3.2
build_daemon 0.5.0
build_modules 1.0.10 2.1.0
build_resolvers 1.0.4
build_runner_core 3.0.3
built_collection 4.2.0
built_value 6.4.0
charcode 1.1.2
code_builder 3.2.0
collection 1.14.11
convert 2.1.1
crypto 2.0.6
dart_style 1.2.4 1.2.7
fixnum 0.10.9
front_end 0.1.14 0.1.15
glob 1.1.7
graphs 0.2.0
http 0.12.0+2
http_multi_server 2.0.5
http_parser 3.1.3
io 0.3.3
js 0.6.1+1
json_annotation 2.2.0
kernel 0.3.14 0.3.15
logging 0.11.3+2
matcher 0.12.5
meta 1.1.7
mime 0.9.6+2
package_config 1.0.5
package_resolver 1.0.10
path 1.6.2
pool 1.4.0
protobuf 0.13.11
pub_semver 1.4.2
pubspec_parse 0.1.4
quiver 2.0.3
scratch_space 0.0.3+2
shelf 0.7.5
shelf_web_socket 0.2.3
source_maps 0.10.8
source_span 1.5.5
stack_trace 1.9.3
stream_channel 2.0.0
stream_transform 0.0.17
string_scanner 1.0.4
term_glyph 1.1.0
timing 0.1.1+1
typed_data 1.1.6
watcher 0.9.7+10
web_socket_channel 1.0.12
yaml 2.1.15